%global gem_name ovirt-engine-sdk
%global gem_version 4.2.5

Name: rubygem-ovirt-engine-sdk4
Summary: oVirt Engine Ruby SDK
Version: 4.2.5
Release: 1%{?dist}
Group: Development/Languages
License: ASL 2.0
URL: http://ovirt.org/wiki/SDK
Source: https://rubygems.org/downloads/%{gem_name}-%{gem_version}.gem

BuildRequires: gcc
BuildRequires: libcurl-devel
BuildRequires: libxml2-devel
BuildRequires: ruby-devel
BuildRequires: rubygems-devel

%description
This package contains the oVirt Engine Ruby Software Develpment Kit.

%package doc
Summary: Documentation for %{name}
Group: Documentation
Requires: %{name} = %{version}-%{release}

%description doc
This package contains documentation for %{name}.

%prep

# Unpack the gem:
gem unpack %{SOURCE0}
%setup -q -D -T -n %{gem_name}-%{gem_version}

# Extract the specification of the gem:
gem spec %{SOURCE0} -l --ruby > %{gem_name}.gemspec

# Replace the version of the gem with the version of the package. This is
# needed because the "gem_build" macro assumes that the name of the .gem file
# is "ovirt-engine-sdk-4.0.0.gem", but it actually is
# "ovirt-engine-sdk-4.0.0.Alpha0".
sed -i 's/"%{gem_version}"/"%{version}"/' %{gem_name}.gemspec

%build

# Create again the .gem file from the potentially modified sources and
# specification:
gem build %{gem_name}.gemspec

# Compile the extensions and install the gem files:
%gem_install

# Remove things that we don't want to package:
pushd ./%{gem_dir}
  rm -rf cache
popd
pushd ./%{gem_instdir}
  rm -rf Rakefile
  rm -rf ext
popd

%install

# Install the files:
mkdir -p %{buildroot}%{gem_dir}
cp -a ./%{gem_dir}/* %{buildroot}%{gem_dir}/

# Install the extensions:
mkdir -p %{buildroot}%{gem_extdir_mri}/lib
mv %{buildroot}%{gem_instdir}/lib/*.so %{buildroot}%{gem_extdir_mri}/lib/

%files
%doc %{gem_instdir}/CHANGES.adoc
%doc %{gem_instdir}/README.adoc
%exclude %{gem_dir}/doc/
%license %{gem_instdir}/LICENSE.txt
%{gem_dir}/specifications/%{gem_name}-%{version}.gemspec
%{gem_extdir_mri}/
%{gem_instdir}/

%files doc
%{gem_dir}/doc/%{gem_name}-%{version}/

%changelog
* Tue Apr 17 2018 Ondra Machacek <omachace@redhat.com> - 4.2.5-1
- Update to upstream 4.2.5.
- Update to model 4.2.37.

* Tue Apr 17 2018 Ondra Machacek <omachace@redhat.com> - 4.2.4-1
- Update to upstream 4.2.4.
- Update to model 4.2.32.

* Wed Feb 21 2018 Ondra Machacek <omachace@redhat.com> - 4.2.3-1
- Update to upstream 4.2.3.
- Expose `syncAllNetworks` command for `HostService`.
- Move `VmPlacementPolicy` attribute from Vm to `VmBase` #1375678.
- Document `JobsService` as a searchable entity.
- Add `lease` parameter to preview snapshot #1532577.
- Update depedency on json lib #1542879.

* Mon Dec 18 2017 Juan Hernandez <juan.hernandez@redhat.com> - 4.2.2-1
- Deprecate the `discard_zeroes_data` attribute of the `LogicalUnit`
  type and the `supports_discard_zeroes_data` of the `StorageDomain`
  type, as they have been removed from the kernel.
- Add new `content_type` attribute to the `Disk` type #1511420.
- Make CPU type optional when adding a cluster #1525912.
- Add support for setting external network providers by name when adding
  or updating a cluster #1511369.
- Add new `unmanaged` attribute to the `OpenStackNetworkProvider` type.
- Move virtual NIC profile mappings insde registration configuration #1522799.
- Added new `discovered_targets` output parameter to the operation that
  discovers host iSCSI storage #1510860.

* Wed Dec 13 2017 Juan Hernandez <juan.hernandez@redhat.com> - 4.2.1-1
- Update to upstream 4.2.1.
- Fix handling of the `all_content` parameter #1525555.
- Limit the number of requests sent to `libcurl` #1525302.

* Mon Dec 4 2017 Juan Hernandez <juan.hernandez@redhat.com> - 4.2.0-1
- Update to upstream 4.2.0.
- Update to model 4.2.26.
- Don't include sensible data in `inspect` #1513620.
- Add new `S390X` value to the `Architecture` type.
- Add new `DIAG288` value to the `WatchdogModel` type.
- Add `OVA` value to the `ConfigurationType` enumerated type.
- Add search parameters to the operation that lists jobs.
- Add `auto_sync` attribute to the _OpenStack_ network provider type #1511823.
- Add operation to export a virtual machine as `OVA` file.
- Add `active` and `transferred` attributes to the `ImageTransfer` type.
- Add `external_provider` and `external_provider_physical_network`
  attributes to the `Network` type.
- Add `transfer_url` to the `ImageTransfer` type.
- Fix input detail of the operation that exports a virtual machine: it
  is mandatory to have the identifier or name of the destination
  storage domain.
- Add support for method extensions.
- Add the `follow` parameter to all the `Get` and `List` operations.
- Add the `force` parameter to the operation that puts a storage domain
  into maintenance mode #1321585.
- Deprecate the _OpenStack_ network provider `pluginType` attribute,
  replacing it with `externalPluginType`.
- Add `quota` and `diskProfile` parameters to the operations that move
  and copy disks #1496704.
- Add `authenticatedUser` and `effectiveUser` links to the `Api` type #1472418.
- Add support for cookies.
- Add `connect_timeout` parameter #1508944.
- Check the types of the `HttpClient` constructor parameters.
- Require `redhat-rpm-config` for building #1505427.
- Don't send `Expect: 100-continue` #1509910.
- Add new services and types to enable automatic provisioning of
  external network providers during host installation.
- Explicitly indicate that CPU type is mandtory when adding a cluster.
- Add `image` parameter to `HostService.upgrade` #1488434.
- Add `storageErrorResumeBehaviour` to virtual machines, templates and
  instance types #1317450.
- Don't require name or identifier for adding SSH public key #1497641.
- Add `reboot` parameter to the `upgrade` method of the service that
  manages a host.
- Add `registrationConfiguration` parameter to the operations that
  register virtual machines and templates.
- Add documentation explaining how to add snapshots with disk
  attachments.
- Add documentation explaining how to add a template with disks in
  specific storage domains #1492614.
- Add `vnicProfileMappings` parameter to the operation that registers a
  template.
- Check types of service method parameters #1378113.
- Check types of HTTP client constructor parameters.
- Add new `NicNetworkFilterParameter` type and related services.
- Add `StorageDomainDisks` and `AttachedStorageDomainDisks`.
- Add operation to register storage domain disk.
- Add `all_content` parameter to snapshots services.
- Add `default_route` value to the `NetworkUsage` enum.
- Add `volatile` parameter to the method that starts a virtual machine.
- Add `RefreshLun` method to the service that manages a disk #1404389.
- Add `firewal_type` attribute to the `Cluster` type.
- Add `has_illegal_images` attribute to the `Vm` type.
- Add support for creating image transfers using disks and snapshots.
- Add `size` and `type` properties to the `Image` type.
- Add `total_size` attribute to the `Disk` type.
  them for clusters.
- Storage domain identifier isn't mandatory to create quota limit.
- Don't require deprecated affinity group attributes #1488729.
- Fix optional fields in storage domain add and update #1488929.
- Add new `HIGH_PERFORMANCE` value to the `VmType` enum.
- Add new types and services for access to system configuration options.
- Add `AuthError`, `ConnectionError`, `NotFoundError` and `TimeoutError`.
- Add a method to Probe to check whether an ovirt instance exists.
- Changing `bundler` executable instead of `bundle` #1462664.
- Ignore unrelated responses from server #1459254.

* Fri Oct 13 2017 Juan Hernandez <juan.hernandez@redhat.com> - 4.1.9-1
- Update to upstream 4.1.9.
- Update to model 4.1.39.
- Add a `refresh` parameter to `FilesService.list`.
- Add support for Link Layer Discovery Protocol (LLDP).
- Add support for listing cluster level features, and enabling/disabing
  them for clusters.
- Improve log messages so that in addition to the response codes they
  also contain the request method and URL.
- Add support for multiple threads #1496846.

* Mon Jul 17 2017 Juan Hernandez <juan.hernandez@redhat.com> - 4.1.8-1
- Update to upstream 4.1.8.
- Update to model 4.1.37.
- Add the `all_content` parameter to `Host.Get` and `Hosts.List` #1444081.
- Fix the documentation of the method that lists events #1447622.
- Fix the direction of the main parameter of the method that adds a
  CDROM to a virtual machine. It should be input and output.
- Improve the documentation explaining that in general the order of the
  results of _list_ methods isn't guaranteed.
- Add the `index` attribute to the `Event` type #1448511.
- Add a new `Probe.exists?` method to check whether an oVirt instance
  exists.
- Handle correctly HTTP 201 and 200 response codes.
- Ignore unreleated responses from server #1459254.
- Use `bundler` instead of `bundle` #1462664.
- Fix missing `curl_multi_wait` symbol when using libcurl older
  than 7.28.0.

* Wed May 31 2017 Juan Hernandez <juan.hernandez@redhat.com> - 4.1.6-1
- Update to upstream 4.1.6.
- Update to model 4.1.17.
- Replace generic assigned networks services with services specific to
  the type of object that they are assigned to, in particular data
  centers and clusters.
- Add `driver` attribute to `HostDevice` type.
- Add common concepts document.
- Add appendix containing changes from version 3 to version 4 of
  the API.
- Add `readOnly` attribute to the `DiskAttachment` type.
- Fix the type of the `Host.nics` link. It should be of type
  `HostNic[]`, not `Nic[]`.
- Add support for asynchronous requests.
- Automatically replace bad tokens #1434831.
- Improve error message for wrong content type #1440292.
- Add `Error.code` #1443420.
- Add `Error.fault`.
- Add support for request timeout.

* Wed Mar 15 2017 Juan Hernandez <juan.hernandez@redhat.com> - 4.1.5-1
- Update to upstream 4.1.5.
- Update to model 4.1.33.
- Replace the `Seal` operation of the service that manages a
  template with a new `seal` parameter in the operation that
  adds a template #1335642.
- Add `unregistered` parameter for the operations to list disks,
  virtual machines, and templates in storage domains #1428159.
- Fix the direction of the `statistic` parameter of the `Statistic`
  service, must be out only.
- Revert the addition of the operation to update disks.

* Fri Mar 3 2017 Juan Hernandez <juan.hernandez@redhat.com> - 4.1.4-1
- Update to upstream 4.1.4.
- Don't avoid reserved words in enum values text.
- Read correctly attributes with enum values #1428642.

* Thu Mar 2 2017 Juan Hernandez <juan.hernandez@redhat.com> - 4.1.3-1
- Update to upstream 4.1.3.
- Update to model 4.1.31.
- Don't require `json` 1.8, as it makes the SDK incompatible with
  applications that need version 2.0 or newer.
- Use `curl-config` to detect `libcurl`, if possible.
- Add `auto_storage_select` attribute to the `VmPool` type.
- Move `vnic_profile_mappings` and `reassign_bad_macs` from
  the `import` operation to the `register` operation
- Add IPv6 details to the `NicConfiguration` type.
- Add NFS 4.2 support.
- Add support for custom headers and query parameters.
- Ignore unsupported enum values.
- Check that URL has been provided.
- Send INFO log messages with summaries of requests and responses.

* Tue Jan 31 2017 Juan Hernandez <juan.hernandez@redhat.com> - 4.1.0-1
- Update to upstream 4.1.0.
- Add `execution_host` link to the `Step` type.
- Add new `lease` attribute to virtual machines and templates.
- Accept CA files and strings.

* Thu Jan 12 2017 Juan Hernandez <juan.hernandez@redhat.com> - 4.1.0-0.1.alpha2
- Update to upstream 4.1.0.alpha2.
- Update to model 4.1.26.
- Add services to support disk attachments of virtual machines available
  for import from storage domains.
- Add `gluster` value to the `NetworkUsage` enum.
- Add `force` parameter to the operation that updates a storage server
  connection.
- Fix the type of the `ticket` parameter of the `VmService.ticket` method.
- Fix the type of the `authentication_method` attribute of the `Ssh` type.
- Rename the `AuthenticationMethod` enum type to `SshAuthenticationMethod`.
- Fix the name of the `exclusive` parameter o the `TemplateService.export`
  method.
- Add the missing `cluster` parameter to the `OpenstackImageService.import`
  method.
- Move the `quota` link from the `Vm` type to the `VmBase` type.
- Add missing `template` and `storage_domain` parameters to the operation
  that imports an image.
- Add the `next_run` parameter to the operation that updates a virtual
  machine.
- Add the `all_content` parameters to the operations that list and
  retrieve virtual machines.
- Implement `==` and `eql?` for types #1383613.
- Added new `v4` value to the `StorageFormat` enum.
- Add `seal` operation to the service that manages templates.
- Add `progress` attribute to the `Disk` and `Step` types.
- Add `allow_partial_import` parameter to the operations that import
  virtual machines and templates.
- Add `ticket` operation to the service that manages the graphics
  console of a virtual machine.
- Added `urandom` to the `RngSource` enumerated type.
- Added `migratable` flag to the `VnicProfile` type.
- Add `gluster_tuned_profile` to the `Cluster` type.
- Add `skip_if_gluster_bricks_up` and `skip_if_gluster_quorum_not_met`
  attributes to the `FencingPolicy` type.
- Add the `ImageTransferDirection` enumerated type and the `direction`
  attribute to the `ImageTransfer` type.
- Replace the generic `GraphicsConsole` and `GraphicsConsoles` with
  specific services for virtual machines, templates and instance
  types.
- Deprecate the `legacy` USB type.
- Add `remoteviewerconnectionfile` action to the `GraphicsConsole`
  service.
- Add `max` attribute to the `MemoryPolicy` type.
- Make `Ip.version` optional.
- Add the `active_slave` link to the `Bonding` type.
- Add DNS configuration support to `Network` and `NetworkAttachment`.
- Add the `uses_scsi_reservation` attribute to the `DiskAttachment`
  type.
- Add the `sparsify` method to `DiskService`.
- Add the `discard_max_size` and `discard_zeroes_data` to the
  `LogicalUnit` type.
- Add `logical_name` attribute to the disk attachment type.
- Add the `upgradecheck` action to the host service.
- Add the `original_template` link to the virtual machine type.
- Require Ruby 2.
- Enable compression by default #1370464.
- Add `succeeded` parameter to the operation that end an external job.
- Add `initial_size` attribute to the `Disk` type.
- Fix writing 'id' attribute for enum values #1408839.
- Enable installation in Vagrant with embedded Ruby #1411594.

* Fri Oct 7 2016 Juan Hernandez <juan.hernandez@redhat.com> - 4.0.3-1
- Update to upstream 4.0.3.
- Remove dependency on the `curb` gem #1377682.

* Tue Oct 4 2016 Juan Hernandez <juan.hernandez@redhat.com> - 4.0.2-1
- Update to upstream 4.0.2.
- Add generic `Writer.write` method to support generating XML from
  objects of unknown types.
- Add new `Probe.probe` method to detect the versions of the API
  supported by the server.
- Add support for optional parameters to update methods.
- Use XML schema naming exceptions to correctly generate tag names like
  `openstack_image_provider`.
- Write correctly lists of enum values #1378066.
- Write correctly empty lists of enum values.

* Tue Sep 6 2016 Juan Hernandez <juan.hernandez@redhat.com> - 4.0.1-1
- Update to upstream 4.0.1.
- Update to model 4.0.33.
- Add the `custom_scheduling_policy_properties` attribute to the `Cluster`
  type.
- Add services and types to support transfer of images.
- Add generic reader.
- Remove the `add` and `remove` operations of virtual machine CDROMs.
- Fix the type of the `usages` attribute of the `Network` type, it
  should be a list of values of the `NetworkUsage` enum, not a list
  of strings.
- Fix reading of lists of elements #1373436.
- Accept `action` and `fault` from actions.
- Fix reading of list of primitive and enum types.

* Mon Aug 29 2016 Juan Hernandez <juan.hernandez@redhat.com> - 4.0.0-1
- Update to upstream 4.0.0.

* Mon Aug 22 2016 Juan Hernandez <juan.hernandez@redhat.com> - 4.0.0-0.19.alpha21
- Update to upstream 4.0.0.alpha21.
- Don't send password using GET and query parameter #1368385.
- Add `logical_name` attribute to the disk attachment type.
- Add the `clone_permissions` parameter to the operations that add virtual machines
  and templates.
- Add the `clone` parameter to the operation that adds a new virtual machine.
- Add the `ad_partner_mac` attribute to the bonding type.
- Add the `ad_aggregator_id` attribute to the host NIC type.
- Add the `ExternalVmImportsService` and related types.
- Add support for secondary parameters #1366548.
- Fix the name of the parameter to get virtual machine from affinity label, should
  be `vm` instead of `host`.

* Tue Jul 19 2016 Juan Hernandez <juan.hernandez@redhat.com> - 4.0.0-0.16.alpha17
- Update to upstream 4.0.0.alpha17.
- Update to model 4.0.28.
- Added `switch_type` attribute to `Host` type.
- Add `permits` to the cluster level type.
- Add the `current` parameter to the virtual machine graphics consoles service.
- Fix the name of the output parameter of the method to list affinity
  groups, should be `groups` instead of `list`.

* Fri Jul 15 2016 Juan Hernandez <juan.hernandez@redhat.com> - 4.0.0-0.16.alpha16
- Update to upstream 4.0.0.alpha16.
- Use 'Logger' instead of file for the ':log' parameter of the connection class.
- Add 'dig' method to all types.

* Mon Jul 11 2016 Juan Hernandez <juan.hernandez@redhat.com> - 4.0.0-0.15.alpha15
- Update to upstream 4.0.0.alpha15.

* Fri Jul 1 2016 Juan Hernandez <juan.hernandez@redhat.com> - 4.0.0-0.14.alpha14
- Update to upstream 4.0.0.alpha14.

* Fri Jan 8 2016 Juan Hernandez <juan.hernandez@redhat.com> - 4.0.0
- Initial packaging.
